Require Import String.

Require Import ssreflect ssrfun ssrbool eqtype ssrnat div seq.
Require Import ssralg fintype perm.
Require Import dvdring matrix  bigop zmodp mxalgebra.
Require Import rank prime.

Set Implicit Arguments.
Unset Strict Implicit.
Import Prenex Implicits.

Require Import infra QArith_base Qcanon.


Notation "n %:Q" := (n%Z : Qcb) (at level 2, left associativity, format "n %:Q").

(* specialization of the rank for the field of rational Q *)
Definition erank := @ex_Rank Qcb_fieldType.

(* dummy tests *)
Definition id1 : Matrix Qcb_fieldType := ident _ 1%N.
Definition id2 : Matrix Qcb_fieldType := ident _ 2%N.
Definition foo : Matrix Qcb_fieldType := cM 0 [::1 %:Q] [::1 %:Q ] (cM 0 [::] [::] (@eM _)).


(* specialization of the determinant for the field of rational Q *)
Definition edet := @ex_Det Qcb_fieldType.

Time Eval vm_compute in
  edet 2 (cM 1%:Q [:: 2%:Q] [:: 3%:Q] (cM 4%:Q [::] [::] (@eM _))).

Time Eval vm_compute in edet 4
  (cM 1%:Q [:: 2%:Q ; 3%:Q ; 4%:Q] [:: 5%:Q; 9%:Q ; 3%:Q]
    (cM 6%:Q [:: 7%:Q; 8%:Q] [:: 10%:Q ; 2%:Q]
      (cM 28%:Q [:: 0%:Q] [:: 2%:Q]
        (cM (-1%:Q) [::] [::] (@eM _))))).


Time Eval vm_compute in edet 9
  (cM 1%:Q  [:: 2%:Q ;  3%:Q ;  4%:Q ; (-2)%:Q ;  3%:Q ; 7%:Q ;  8%:Q ; 1%:Q]      [::  5%:Q ; 9%:Q ; 3%:Q ; 1%:Q ; 5%:Q ; 9%:Q ;  3%:Q ; 3%:Q ]
    (cM  6%:Q  [:: 7%:Q ;  8%:Q ; 14%:Q ; 21%:Q ; 5%:Q ; 12%:Q ; 2%:Q]
      [:: 10%:Q ; 2%:Q ; 2%:Q ; 6%:Q ; 10%:Q ; 2%:Q ;  2%:Q]
    (cM 28%:Q  [:: 0%:Q ;  9%:Q ;  7%:Q ; 6%:Q ; 11%:Q ; 3%:Q]
       [:: 2%:Q ; 3%:Q ; 7%:Q ; 29%:Q ; 2%:Q ; 2%:Q]
    (cM (-1)%:Q  [:: 1%:Q ;  2%:Q ; 3%:Q ;  4%:Q ; 4%:Q]
      [:: 4%:Q ; 8%:Q ;  0%:Q ; (-1)%:Q ; (-1)%:Q ]
    (cM (-2)%:Q  [::  3%:Q ; 9%:Q ;  8%:Q ; 5%:Q]
      [:: 3%:Q ; 5%:Q ; 0%:Q ; 0%:Q]
    (cM 13%:Q  [:: 5%:Q ; 12%:Q ; 6%:Q]
      [:: 25%:Q ; 0%:Q ; 0%:Q]
    (cM 6%:Q [:: 11%:Q ; 7%:Q] [:: 0%:Q ; 3%:Q]
    (cM 0%:Q [:: 8%:Q] [:: 0%:Q] (cM 9%:Q [::] [::] (@eM _)))))))))).

Definition M77 :=
  (cM 45%:Q [:: 1%:Q; (-25)%:Q; 0%:Q ; 7%:Q; 5%:Q; 0%:Q]
      [:: 1%:Q; (-25)%:Q; 0%:Q ; 7%:Q; 5%:Q; 0%:Q]
      (cM 78%:Q [:: 39%:Q; (-4)%:Q; 0%:Q; 11%:Q ; (-1)%:Q]
        [:: 39%:Q; (-4)%:Q; 0%:Q; 11%:Q ; (-1)%:Q]
       (cM 20%:Q [:: 0%:Q; 1%:Q; (-7)%:Q; (-7)%:Q]
          [:: 0%:Q; 1%:Q; (-7)%:Q; (-7)%:Q]
          (cM (-14)%:Q [:: 1%:Q; 2%:Q; 3%:Q]
            [:: 1%:Q; 2%:Q; 3%:Q]
            (cM 17%:Q [:: 10%:Q ; 3%:Q ]
              [:: 10%:Q ; 3%:Q ]
              (cM 4%:Q [:: 2%:Q] [:: 2%:Q]
                (cM 0%:Q [::] [::] (@eM _)))))))).

Time Eval vm_compute in (edet 7 M77).
Time Eval vm_compute in (erank 7 M77).


Definition foo4 : Matrix Qcb_fieldType :=
 cM 2 %:Q [:: 4%:Q ; 1%:Q ; 3%:Q] [:: (-1)%:Q; 0%:Q; 3%:Q]
   (cM (-2%:Q) [:: 1%:Q; 0%:Q] [:: 0%:Q; 6%:Q] (cM 2%:Q [:: 2%:Q] [:: 2%:Q] (
   cM 5%:Q [::] [::] (@eM _)))).

:Eval vm_compute in (ex_Rank 4 foo4).
Eval vm_compute in (edet 4 foo4).

Definition foo4' : Matrix Qcb_fieldType :=
 cM 3 %:Q [:: 5%:Q ; 1%:Q ; 3%:Q] [:: (-1)%:Q; 0%:Q; 3%:Q]
   (cM (-2%:Q) [:: 1%:Q; 0%:Q] [:: 0%:Q; 6%:Q] (cM 2%:Q [:: 2%:Q] [:: 2%:Q] (
   cM 6%:Q [::] [::] (@eM _)))).

Time Eval vm_compute in (ex_Rank 4 foo4').
Time Eval vm_compute in (edet 4 foo4').


Eval vm_compute in (ex_Rank 2 foo).


Definition ex1 :=  cM 1%:Q [:: 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q] [:: 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 1%:Q ; 0%:Q ; 0%:Q] [:: 1%:Q ; 0%:Q ; 0%:Q] (cM 1%:Q [:: 0%:Q ; 1%:Q] [:: 0%:Q ; 0%:Q] (cM 1%:Q [:: 1%:Q] [:: 0%:Q] (cM 0%:Q [::] [::] (@eM _ ))))).
Definition ex1_size := 5.


Compute "ex1"%string.
Time Eval vm_compute in (ex_Rank ex1_size ex1).
Time Eval vm_compute in (ex_Det ex1_size ex1).

Definition ex2 := cM 1%:Q [:: 0%:Q] [:: 1%:Q] (cM 1%:Q [::] [::] (@eM _ )).
Definition ex2_size := 2.

Compute "ex2"%string.
Time Eval vm_compute in (ex_Rank ex2_size ex2).
Time Eval vm_compute in (edet 2 ex2).

Definition ex3 := cM 1%:Q [:: 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 1%:Q [:: 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 1%:Q [:: 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q] [:: 0%:Q] (cM 0%:Q [::] [::] (@eM _ )))))))))))))))))))))))))))))))).
Definition ex3_size := 32.


Compute "ex3"%string.
Time Eval vm_compute in (ex_Rank ex3_size ex3).
Time Eval vm_compute in (edet ex3_size ex3).

Definition ex4 := cM 1%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 1%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 1%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 1%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q] [:: 0%:Q] (cM 0%:Q [::] [::] (@eM _ )))))))))))))))).
Definition ex4_size := 16.

Compute "ex4"%string.
Time Eval vm_compute in (ex_Rank ex4_size ex4).
Time Eval vm_compute in (ex_Det ex4_size ex4).


Definition ex5 := cM 1%:Q [:: 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 1%:Q [:: 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 1%:Q [:: 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q] [:: 0%:Q] (cM 0%:Q [::] [::] (@eM _ )))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))).
Definition ex5_size := 64.

Compute "ex5"%string.
Time Eval vm_compute in (ex_Rank ex5_size ex5).
Time Eval vm_compute in (ex_Det ex5_size ex5).

Definition ex6 := cM 1%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 1%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 1%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 1%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 1%:Q ; 1%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q] [:: 0%:Q] (cM 0%:Q [::] [::] (@eM _ )))))))))))))))))))))))))))))))).
Definition ex6_size := 32.

Compute "ex6"%string.
Time Eval vm_compute in (ex_Rank ex6_size ex6).
Time Eval vm_compute in (ex_Det ex6_size ex6).

Definition ex7 := cM 1%:Q [:: 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 1%:Q ; 1%:Q ; 1%:Q ; 0%:Q] [:: 0%:Q ; 0%:Q] (cM 0%:Q [:: 0%:Q ; 1%:Q ; 0%:Q ; 1%:Q] [:: 0%:Q] (cM 0%:Q [:: 0%:Q ; 1%:Q ; 1%:Q] [:: ] ((@eM _ )))))))).
Definition ex7_size := 7.

Compute "ex7"%string.
Time Eval vm_compute in (ex_Rank ex7_size ex7).
Time Eval vm_compute in (ex_Det ex7_size ex7).

Definition ex8 := cM 1%:Q [:: 0%:Q] [:: 1%:Q ; 0%:Q ; 1%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q ; 0%:Q] ((@eM _ )).
Definition ex8_size := 10.

Compute "ex8"%string.
Time Eval vm_compute in (ex_Rank ex8_size ex8).
Time Eval vm_compute in (ex_Det ex8_size ex8).
